#ifndef _H_8711FCFA24772FA32D1E610F880DD730_TestTopicServiceResponse_DCPS_H_
#define _H_8711FCFA24772FA32D1E610F880DD730_TestTopicServiceResponse_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TestTopicServiceResponse_.h"


namespace swri_roscpp
{
    namespace msg
    {
        namespace dds_
        {
            class TestTopicServiceResponse_TypeSupportInterface;

            typedef TestTopicServiceResponse_TypeSupportInterface * TestTopicServiceResponse_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceResponse_TypeSupportInterface> TestTopicServiceResponse_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceResponse_TypeSupportInterface> TestTopicServiceResponse_TypeSupportInterface_out;


            class TestTopicServiceResponse_DataWriter;

            typedef TestTopicServiceResponse_DataWriter * TestTopicServiceResponse_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceResponse_DataWriter> TestTopicServiceResponse_DataWriter_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceResponse_DataWriter> TestTopicServiceResponse_DataWriter_out;


            class TestTopicServiceResponse_DataReader;

            typedef TestTopicServiceResponse_DataReader * TestTopicServiceResponse_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceResponse_DataReader> TestTopicServiceResponse_DataReader_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceResponse_DataReader> TestTopicServiceResponse_DataReader_out;


            class TestTopicServiceResponse_DataReaderView;

            typedef TestTopicServiceResponse_DataReaderView * TestTopicServiceResponse_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TestTopicServiceResponse_DataReaderView> TestTopicServiceResponse_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TestTopicServiceResponse_DataReaderView> TestTopicServiceResponse_DataReaderView_out;

            struct TestTopicServiceResponse_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TestTopicServiceResponse_, struct TestTopicServiceResponse_Seq_uniq_> TestTopicServiceResponse_Seq;
            typedef DDS_DCPSSequence_var < TestTopicServiceResponse_Seq> TestTopicServiceResponse_Seq_var;
            typedef DDS_DCPSSequence_out < TestTopicServiceResponse_Seq> TestTopicServiceResponse_Seq_out;

            class  TestTopicServiceResponse_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TestTopicServiceResponse_TypeSupportInterface_ptr _ptr_type;
                typedef TestTopicServiceResponse_TypeSupportInterface_var _var_type;

                static TestTopicServiceResponse_TypeSupportInterface_ptr _duplicate (TestTopicServiceResponse_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceResponse_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceResponse_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TestTopicServiceResponse_TypeSupportInterface () {};
                ~TestTopicServiceResponse_TypeSupportInterface () {};
            private:
                TestTopicServiceResponse_TypeSupportInterface (const TestTopicServiceResponse_TypeSupportInterface &);
                TestTopicServiceResponse_TypeSupportInterface & operator = (const TestTopicServiceResponse_TypeSupportInterface &);
            };

            class  TestTopicServiceResponse_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TestTopicServiceResponse_DataWriter_ptr _ptr_type;
                typedef TestTopicServiceResponse_DataWriter_var _var_type;

                static TestTopicServiceResponse_DataWriter_ptr _duplicate (TestTopicServiceResponse_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceResponse_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceResponse_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TestTopicServiceResponse_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TestTopicServiceResponse_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TestTopicServiceResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TestTopicServiceResponse_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestTopicServiceResponse_& instance_data) = 0;

            protected:
                TestTopicServiceResponse_DataWriter () {};
                ~TestTopicServiceResponse_DataWriter () {};
            private:
                TestTopicServiceResponse_DataWriter (const TestTopicServiceResponse_DataWriter &);
                TestTopicServiceResponse_DataWriter & operator = (const TestTopicServiceResponse_DataWriter &);
            };

            class  TestTopicServiceResponse_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TestTopicServiceResponse_DataReader_ptr _ptr_type;
                typedef TestTopicServiceResponse_DataReader_var _var_type;

                static TestTopicServiceResponse_DataReader_ptr _duplicate (TestTopicServiceResponse_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceResponse_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceResponse_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TestTopicServiceResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TestTopicServiceResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TestTopicServiceResponse_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestTopicServiceResponse_& instance) = 0;

            protected:
                TestTopicServiceResponse_DataReader () {};
                ~TestTopicServiceResponse_DataReader () {};
            private:
                TestTopicServiceResponse_DataReader (const TestTopicServiceResponse_DataReader &);
                TestTopicServiceResponse_DataReader & operator = (const TestTopicServiceResponse_DataReader &);
            };

            class  TestTopicServiceResponse_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TestTopicServiceResponse_DataReaderView_ptr _ptr_type;
                typedef TestTopicServiceResponse_DataReaderView_var _var_type;

                static TestTopicServiceResponse_DataReaderView_ptr _duplicate (TestTopicServiceResponse_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TestTopicServiceResponse_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TestTopicServiceResponse_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TestTopicServiceResponse_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TestTopicServiceResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TestTopicServiceResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TestTopicServiceResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TestTopicServiceResponse_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TestTopicServiceResponse_& instance) = 0;

            protected:
                TestTopicServiceResponse_DataReaderView () {};
                ~TestTopicServiceResponse_DataReaderView () {};
            private:
                TestTopicServiceResponse_DataReaderView (const TestTopicServiceResponse_DataReaderView &);
                TestTopicServiceResponse_DataReaderView & operator = (const TestTopicServiceResponse_DataReaderView &);
            };
        }

    }

}

#endif
